

from Server.Client.Core import test_helper
BASE_CONTAINER = 'cltest'
from Ft.Server.Common import AclConstants
from Ft import FT_DIR, SHARE_DIR
import os, sha

def InitRepo(tester,custom,command):

    tester.startGroup("Init the repo for command line tests")

    tester.startTest("Init %s" % BASE_CONTAINER)

    repo = test_helper.GetRepo(tester)
    if repo.hasResource(BASE_CONTAINER):
        repo.deleteResource(BASE_CONTAINER)
    repo.createContainer(BASE_CONTAINER)

    ddRoot = repo.fetchResource('/ftss/docdefs')
    if ddRoot.hasResource('def1'):
        ddRoot.deleteResource('def1')
    if ddRoot.hasResource('def2'):
        ddRoot.deleteResource('def2')

    if repo.hasResource('/ftss/data'):
        repo.deleteResource('/ftss/data')
    data = repo.createContainer('/ftss/data')
    data.createDocument('cl-container.xslt',open(os.path.join(SHARE_DIR,'Data','Stylesheets','cl-container.xslt')).read())

    uuRoot = repo.fetchResource('/ftss/users')
    if uuRoot.hasResource('test1'):
        uuRoot.deleteResource('test1')
    if uuRoot.hasResource('test2'):
        uuRoot.deleteResource('test2')

    if uuRoot.hasResource('testUser'):
        uuRoot.deleteResource('testUser')
    uuRoot.createUser('testUser',sha.new('testUser').hexdigest())

    #Add the command to be tested, just stuff some crap in for now
    CreateCommand(repo,command)

    custom(repo)
    repo.txCommit()

    tester.testDone()
    tester.groupDone()


def CreateCommand(repo,command):
    repoFile = '/ftss/commands/' + '.'.join(command)
    if repo.hasResource(repoFile):
        repo.deleteResource(repoFile)
    doc = repo.createDocument(repoFile,"<doc/>")
    doc.setAcl(AclConstants.EXECUTE_ACCESS,AclConstants.USERS_GROUP_NAME,1)

