from Xml.Xslt import test_harness


expected_1 = """<HTML>
  <HEAD>
    <meta http-equiv='Content-Type' content='text/html; charset=iso-8859-1'>
    <TITLE>Address Book</TITLE>
  </HEAD>
  <BODY>
    <H1>Tabulate just the Names</H1>
    <TABLE>
      <TR>
        <TD ALIGN='CENTER'><B ID='pieter.aaron@inter.net'>Pieter Aaron</B></TD>
      </TR>
      <TR>
        <TD ALIGN='CENTER'><B ID='endubuisi@spamtron.com'>Emeka Ndubuisi</B></TD>
      </TR>
      <TR>
        <TD ALIGN='CENTER'><B ID='vxz@magog.ru'>Vasia Zhugenev</B></TD>
      </TR>
    </TABLE>
  </BODY>
</HTML>"""

sheet_2 = """\
<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
version="1.0">

  <xsl:variable name="sty-doc" select="document('')"/>

  <xsl:key name='name' match='*' use='name()'/>

  <xsl:template match="/">
    <xsl:for-each select=".">
      Entries from keys: <xsl:value-of select="count(key('name', 'ENTRY'))"/>
      Template from keys: <xsl:value-of select="count(key('name', 'xsl:template'))"/>
    </xsl:for-each>
    <xsl:for-each select="$sty-doc">
      Entries from keys: <xsl:value-of select="count(key('name', 'ENTRY'))"/>
      Template from keys: <xsl:value-of select="count(key('name', 'xsl:template'))"/>
    </xsl:for-each>
  </xsl:template>

</xsl:stylesheet>
"""

sheet_3 = """\
<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:x="http://spam.com" version="1.0">

  <xsl:variable name="sty-doc" select="document('')"/>

  <xsl:key name='k1' match='xsl:*' use='name()'/>
  <xsl:key name='k2' match='x:*' use='@id'/>

  <x:grail id="ein"/>
  <x:grail id="zwo"/>
  <x:knicht id="drei"/>
  <x:knicht id="vier"/>

  <xsl:template match="/">
    <xsl:for-each select="$sty-doc">
      Entries from k1: <xsl:copy-of select="count(key('k1', 'xsl:template'))"/>
      Entries from k2: <xsl:copy-of select="count(key('k2', 'drei'))"/>
    </xsl:for-each>
  </xsl:template>

</xsl:stylesheet>
"""

expected_2 = """\
<?xml version='1.0' encoding='UTF-8'?>

      Entries from keys: 3
      Template from keys: 0
      Entries from keys: 0
      Template from keys: 1"""

expected_3 = """\
<?xml version='1.0' encoding='UTF-8'?>

      Entries from k1: 1
      Entries from k2: 1"""


def Test(tester):
    tester.startGroup("Basic keys test")
    source = test_harness.FileInfo(uri="Xml/Xslt/Core/addr_book1.xml", nsAware=0)
    sty = test_harness.FileInfo(uri="Xml/Xslt/Core/addr_book_keyed.xsl")
    test_harness.XsltTest(tester, source, [sty], expected_1)
    tester.groupDone()

    tester.startGroup("Test keys shifting with context doc")
    source = test_harness.FileInfo(uri="Xml/Xslt/Core/addr_book1.xml", nsAware=0)
    sty = test_harness.FileInfo(string=sheet_2)
    test_harness.XsltTest(tester, source, [sty], expected_2, compareFunc=cmp)
    tester.groupDone()

    tester.startGroup("Test keys using patterns of form ns:*")
    source = test_harness.FileInfo(uri="Xml/Xslt/Core/addr_book1.xml", nsAware=0)
    sty = test_harness.FileInfo(string=sheet_3)
    test_harness.XsltTest(tester, source, [sty], expected_3, compareFunc=cmp)
    tester.groupDone()

    return
